﻿namespace Umbraco.Core
{
	public static partial class Constants
	{
		/// <summary>
		/// Defines the alias identifiers for Umbraco's core application sections.
		/// </summary>
		public static class Applications
		{
			/// <summary>
			/// Application alias for the content section.
			/// </summary>
			public const string Content = "content";

			/// <summary>
			/// Application alias for the developer section.
			/// </summary>
			public const string Developer = "developer";

			/// <summary>
			/// Application alias for the media section.
			/// </summary>
			public const string Media = "media";

			/// <summary>
			/// Application alias for the members section.
			/// </summary>
			public const string Members = "member";

			/// <summary>
			/// Application alias for the settings section.
			/// </summary>
			public const string Settings = "settings";

			/// <summary>
			/// Application alias for the translation section.
			/// </summary>
			public const string Translation = "translation";

			/// <summary>
			/// Application alias for the users section.
			/// </summary>
			public const string Users = "users";
		}

        /// <summary>
        /// Defines the alias identifiers for Umbraco's core trees.
        /// </summary>
        public static class Trees
        {
            /// <summary>
            /// alias for the content tree.
            /// </summary>
            public const string Content = "content";

            /// <summary>
            /// alias for the media tree.
            /// </summary>
            public const string Members = "member";

            /// <summary>
            /// alias for the media tree.
            /// </summary>
            public const string Media = "media";

            /// <summary>
            /// alias for the datatype tree.
            /// </summary>
            public const string DataTypes = "datatype";

            //TODO: Fill in the rest!

        }
	}

   
}